{----------------------------------------------------------------------------}
{ Address Bar for Calmira                                                    }
{                                                                            }
{ by Maxim Gready                                                            }
{ http://mwos.cjb.net/address.htm                                            }
{ maxim@mwos.cjb.net                                                         }
{                                                                            }
{ This program and code are free, have fun                                   }
{ No guarantee is offered; it is in constant beta. Typing too fast can       }
{ result in unwanted effects and it occasionally locks up the whole          }
{ computer :(                                                                }
{                                                                            }
{ This program uses Calmira's Drives unit to help with                       }
{ possible future integration..?                                             }
{----------------------------------------------------------------------------}

unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, IniFiles,
  Forms, Dialogs, StdCtrls, ExtCtrls, {Environs, }Buttons, StylSped, Menus, Drives;

type
  TForm1 = class(TForm)
    Edit1: TComboBox;
    PopupMenu1: TPopupMenu;
    Check: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Help1: TMenuItem;
    Image1: TImage;
    Shape1: TShape;
    StyleSpeed1: TStyleSpeed;
    Sitontaskbar1: TMenuItem;
    Stayontop1: TMenuItem;
    Showtaskbaricon1: TMenuItem;
    OpenDialog1: TOpenDialog;
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormPaint(Sender: TObject);
    procedure Shape1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StyleSpeed1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Sitontaskbar1Click(Sender: TObject);
    procedure Stayontop1Click(Sender: TObject);
    procedure Showtaskbaricon1Click(Sender: TObject);
  private
    { Private declarations }
    procedure CheckAndOpen(AddressText:string);
    function CheckForURL(Text:string):Boolean;
    procedure ChangeBitmap(name:PChar);
    procedure LoadFromIni;
    procedure SaveToIni;
    function GetCalmiraIni:string;
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  URLs: TStringList;
  CalmiraDir, DosScriptFilename: string;

implementation

{$R *.DFM}

procedure TForm1.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  SearchRecord: TSearchRec;
  i: integer;
  MaskString: string [3];
  Test: Boolean;
  Result: integer;
  LengthOfTypedBit: byte;
  Rectangle: TRect;
begin
  if not (Key in
    [vk_Home, vk_Back, vk_Return, vk_Shift, vk_Control, vk_Menu {Alt}, vk_Tab,
     vk_Delete, vk_End, vk_Left, vk_Right, vk_Up, vk_Down, vk_Insert, vk_Escape])
    {Reserved keys that I don't want to do anything}
  then begin
    if (length(Edit1.Text)<4) and (uppercase(Edit1.Text)[1] in ValidDrives) then {nicked from calmira :}
    case length(Edit1.Text) of {expand drive letters to root directories}
      1: begin
           Edit1.Text:=Edit1.Text+':\';
           Edit1.SelStart:=1;
           Edit1.SelLength:=3;
           ChangeBitmap('Drive');
         end;
      2: if Edit1.Text[2]=':' then begin
           Edit1.Text:=Edit1.Text+'\';
           Edit1.SelStart:=2;
           Edit1.SelLength:=3;
           ChangeBitmap('Drive');
         end else ChangeBitmap('Dunno');
      3: if (Edit1.Text[2]=':') and (Edit1.Text[3]='\')
           then ChangeBitmap('Drive')
           else ChangeBitmap('Dunno');
      else ChangeBitmap('Dunno');
    end {end case statement}

  else begin {otherwise do a search for a file/dir}
    if pos('.',Edit1.Text)>pos('\',Edit1.Text) then {Sorts out whether to add * or *.*}
      MaskString:='*'
    else
      MaskString:='*.*';

    Result:=findfirst(Edit1.Text+MaskString,faAnyFile,SearchRecord); {Main search}

    Test:=False; {You don't want the . or .. 'directories' or the volume name 'file'}
    repeat
      test:=(SearchRecord.Name='.') or
            (SearchRecord.Name='..') or
            ((SearchRecord.Attr and faVolumeID)>0);
      if test then findnext(SearchRecord);
    until not test;

    FindClose(SearchRecord);

    if (SearchRecord.Attr and faDirectory > 0) then
      SearchRecord.Name:=SearchRecord.Name+'\'; {append \ for a directory}

    SearchRecord.Name:=Lowercase(SearchRecord.Name);

    if Result=0 then begin {if something is found}
      for i:=length(SearchRecord.Name) downto 1 do begin
        if (comparestr(
             copy(lowercase(Edit1.Text), length(Edit1.Text)-i+1, i), {this took ages to work out}
             copy(SearchRecord.Name, 0, i)
           )=0) then begin {if they match then do the selection bit}
             LengthOfTypedBit:=Length(Edit1.text);
             Edit1.Text:=Edit1.Text+Copy(SearchRecord.Name, i+1, Length(SearchRecord.Name)-i);
             Edit1.SelStart:=LengthOfTypedBit;
             Edit1.SelLength:=Length(Edit1.Text)-LengthOfTypedBit;
             i:=1;
        end;
      end;
      if (SearchRecord.Attr and faDirectory >0) {if it's a dir}
       then ChangeBitmap('Folder')
       else ChangeBitmap('File');
    end else{not a file or directory}
      if CheckForURL(Edit1.Text) then ChangeBitmap('URL')
      else ChangeBitmap('Dunno');
    end;
  end else if (Key = vk_Tab) then begin {tab key = end}
    Edit1.SelStart:=Length(Edit1.Text);
  end;
end;

procedure TForm1.CheckAndOpen(AddressText:string);
var
  SearchRecord: TSearchRec;
  F1: TextFile;
  Filename, Action, Path: string;
  typeoffile:char; {r=root u=URL f=file d=directory x=none of the above}
begin
{  AddressText:=lowercase(AddressText);}
  typeoffile:='x';

  if AddressText[length(AddressText)]='\' then AddressText:=copy(AddressText,0,length(AddressText)-1);
  { strip off \ at end which I went to so much effort to add :) }

  if (findfirst(AddressText,faAnyFile,SearchRecord)=0) then
    begin
      if (SearchRecord.Attr and faDirectory>0) then typeoffile:='d' else typeoffile:='f';
    end
  else if ((length(AddressText)=2) and (AddressText[2]=':'))
        then typeoffile:='r'
  else if CheckForURL(Edit1.Text) then typeoffile:='u';

{  Messagebox(0,strPcopy(#0,typeoffile),
    'Information',mb_OK+mb_IconInformation);}


  {this seems a messy way but I can't think how else to do it}

  FindClose(SearchRecord);

  if not (typeoffile='x') or not Check.Checked then begin
{    Filename:=EnvironSubst('%tempscript%'); NO!!! tempscript is the filename before renaming! Doh!}
    FileName:=DosScriptFilename;
{    Filename:='c:\calmira.run';}

    If typeoffile in ['f','u','x'] {set action, Start by default}
      then Action:='Start' else begin
        Action:='Folder';
        AddressText:=AddressText+'\';
      end;
        { The help file says that Start acts like the Run menu but it refuses to
          open folder windows, so Folder must be used :(     }

    if typeoffile in ['f','d','r'] {set path to use }
      then Path:=ExtractFilePath(AddressText)
      else Path:=ExtractFilePath(Filename);

    AssignFile(F1, ExtractFilePath(Filename)+'address.tmp');
    Rewrite(F1);  {create and get ready to write}
    Write(F1, Action+#13+#10+Path+#13+#10+AddressText);
    CloseFile(F1);

    if (fileexists(Filename) and DeleteFile(Filename)) {if the script file exists then try to delete it}
     or not fileexists(Filename) then
      Rename(F1,Filename);
    {Note: this shouldn't be necessary (Calmira should delete it) but it can't hurt...}

    if not (Edit1.Items.IndexOf(AddressText)=-1) {if it's already in the list}
      then Edit1.Items.move(Edit1.Items.IndexOf(AddressText),0) {then move to top of list}
      else Edit1.Items.Insert(0,AddressText); {else add to top of list}
    Edit1.ItemIndex:=0; {this stops the text being cleared}

    if Exit1.Checked then close;
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Edit1.SelectAll;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: byte;
begin
  URLs:=TStringList.Create;
  LoadFromIni;

  {Read in command line parameters}
  for i:=1 to paramcount do begin
    Check.Checked:=not (comparestr(lowercase(paramstr(i)),'nocheck')=0);
    Exit1.Checked:=    (comparestr(lowercase(paramstr(i)),'exit'   )=0);
  end;

  Form1.Height:=30;
{  Form1.Left:=Screen.Width-Form1.Width;
  Form1.Top:=Screen.Height-58;}

  Application.OnActivate:=FormActivate;

  DetectDrives;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=vk_Return) then begin
    CheckAndOpen(Edit1.Text);
    Edit1.ItemIndex:=0;
  end;
  if (Key=vk_Escape) then Close;
end;

function TForm1.CheckForURL(Text:string):Boolean;
var
  i: integer;
begin
  CheckForURL:=False;
  for i:=0 to URLs.Count-1 do
    if comparetext(copy(Text,0,length(URLs[i])),URLs[i])=0 then begin
      CheckForURL:=True;
      exit;
  end;
end;

procedure TForm1.CheckClick(Sender: TObject);
begin
  Check.Checked:=not Check.Checked;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Exit1.Checked:=not Exit1.Checked;
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  Messagebox(0,
    'Address Bar for Calmira version 1.1 12/9/99'+#13+#13+
    'by Maxim Gready'+#13+
    'http://mwos.cjb.net'+#13+
    'maxim@mwos.cjb.net'+#13+#13+
    'If it doesn''t work then you may need Calmira''s DOS'+#13+
    'scripts set up properly (see Calmira''s help file)',
    'Information',mb_OK+mb_IconInformation);
end;

procedure TForm1.ChangeBitmap(name:PChar);
var
  MyBitmap:TBitmap;
begin
  MyBitmap:=TBitmap.Create;
  MyBitmap.Handle:=LoadBitmap(HInstance,name);
  Image1.Picture.Bitmap:=MyBitmap;
  MyBitmap.Free;
end;

procedure TForm1.Edit1Click(Sender: TObject);
begin
{  if not (Edit1.ItemIndex=-1) then CheckAndOpen(Edit1.Items.Strings[Edit1.ItemIndex]);}
end;

procedure TForm1.LoadFromIni;
var
  MyIni, CalIni: tinifile;
  n,i,j: integer;
  Temp: string;
begin
  MyIni:=tinifile.create(extractfilepath(paramstr(0))+'address.ini');

  {look for CalmiraIni; if not found then prompt}
  Temp:=Myini.readString('Settings','CalmiraIni','');
  if Temp='' then Temp:=GetCalmiraIni; {moved to its own procedure because the ifs were getting too nested}

  CalIni:=tinifile.create(Temp); {open Calmira.ini}
  DosScriptFilename:=CalIni.readstring('Scripts','DosScriptFilename',''); {read value}
  CalIni.Free; {close Calmira.ini}

  MyIni.writestring('Settings','CalmiraIni',Temp);

  Check.Checked:=MyIni.readBool('Settings','CheckingOn',True);
  Exit1.Checked:=MyIni.readBool('Settings','AutoExit',False);
  if MyIni.readBool('Settings','StayOnTop',False) then StayOnTop1.Click;
  if not MyIni.readBool('Settings','ShowIcon',True) then Showtaskbaricon1.Click;

  n:=MyIni.ReadInteger('Settings','HistorySize',10);
  Edit1.DropDownCount:=n;
  for i:=0 to n-1 do begin
    Temp:=MyIni.ReadString('History','S'+IntToStr(i),'null');
    if not (Temp='null') then Edit1.Items.Add(Temp);
  end;

  Temp:=MyIni.ReadString('Settings','URLPrefixes','http ftp mailto www')+' ';
  j:=1;
  for i:=1 to length(Temp) do if Temp[i]=' ' then begin
    URLs.add(copy(Temp,j,i-j));
    j:=i+1;
  end;

  Form1.Width:=MyIni.ReadInteger('Settings','Width',360);
  Form1.Left:=MyIni.ReadInteger('Settings','Left',100);
  Form1.Top:=MyIni.ReadInteger('Settings','Top',100);

  MyIni.free;
end;

procedure TForm1.SaveToIni;
var
  MyIni: tinifile;
  n,i: integer;
begin
  MyIni:=tinifile.create(extractfilepath(paramstr(0))+'address.ini');

  MyIni.WriteBool('Settings','CheckingOn',Check.Checked);
  MyIni.WriteBool('Settings','AutoExit',Exit1.Checked);
  MyIni.WriteBool('Settings','StayOnTop',StayOnTop1.Checked);
  MyIni.WriteBool('Settings','ShowIcon',Showtaskbaricon1.Checked);
  n:=MyIni.ReadInteger('Settings','HistorySize',10);
  MyIni.WriteInteger('Settings','HistorySize',n);
  Myini.writestring('Settings','CalmiraDir',CalmiraDir);

  if Edit1.Items.Count<n then n:=Edit1.Items.Count;
  for i:=0 to n-1 do
    MyIni.WriteString('History','S'+IntToStr(i),Edit1.Items[i]);

  MyIni.WriteInteger('Settings','Width',Form1.Width);
  MyIni.WriteInteger('Settings','Left',Form1.Left);
  MyIni.WriteInteger('Settings','Top',Form1.Top);

  MyIni.free;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveToIni;
  URLs.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  with Form1.Canvas do begin
    Pen.Color:=clBtnHighlight;{Form surround}
    MoveTo(1,Form1.Height-3);
    LineTo(1,1);
    LineTo(Form1.Width-2,1);
    Pen.Color:=clBtnShadow;
    MoveTo(Form1.Width-2,1);
    LineTo(Form1.Width-2,Form1.Height-2);
    LineTo(0,Form1.Height-2);
    Pen.Color:=clBlack;
    MoveTo(Form1.Width-1,0);
    LineTo(Form1.Width-1,Form1.Height-1);
    LineTo(-1,Form1.Height-1);
  end;
end;

procedure TForm1.Shape1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssleft in shift then begin
    releasecapture;
    form1.perform(WM_syscommand, $F012, 0);
  end;
end;

procedure TForm1.StyleSpeed1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);
begin
  inherited;
  if (M.Result = htClient) then begin
    if (m.xpos-Form1.Left)<4               then M.Result:=HTLeft;
    if (m.xpos-Form1.Left)>(Form1.Width-4) then M.Result:=HTRight;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Edit1.Width:=Form1.Width-49;
  Form1.Invalidate; {make everything repaint before drawing on top}
  FormPaint(self);
end;

procedure TForm1.Sitontaskbar1Click(Sender: TObject);
begin
  Form1.Left:=Screen.Width-Form1.Width;
  Form1.Top:=Screen.Height-59;
end;

procedure TForm1.Stayontop1Click(Sender: TObject);
begin
  StayOnTop1.Checked:=not StayOnTop1.Checked;
  if StayOnTop1.Checked then Form1.FormStyle:=fsStayOnTop else Form1.FormStyle:=fsNormal;
end;

procedure TForm1.Showtaskbaricon1Click(Sender: TObject);
begin
  if not Showtaskbaricon1.Checked
    then begin
      if Messagebox(0,'The taskbar currently will not allow icons to reappear.'+#13+
      'This setting will therefore not take effect until you restart Address Bar.'+#13+
      'Alternatively, you can use Calmira''s Task Manager to unhide the program.'+#13+
      'Do you want to activate Calmira''s Task Manager?',
      'Information',mb_YesNo+mb_IconQuestion)=6 then
        PostMessage(HWND_BROADCAST, RegisterWindowMessage('Calmira Registered Message'), 4, 0);
    end else begin
    showwindow(application.handle,sw_hide);
    end;
  Showtaskbaricon1.Checked:=not Showtaskbaricon1.Checked;
end;

function Tform1.GetCalmiraIni;
begin
  if OpenDialog1.execute and FileExists(OpenDialog1.filename) then
    Result:=OpenDialog1.filename {if ini file exists}
  else begin{user cancelled open dialogue or chose wrong directory}
    Messagebox(0,
      'Address Bar needs to know a setting from Calmira''s ini file'+#13+
      'in order to work. This file is either in your Calmira directory'+#13+
      'or in your Windows directory if you run Calmira over a network.',
      'Information',mb_OK+mb_IconInformation);
    Halt;
  end;
end;

end.
